// theoretically this should be the only file that needs changing . . .

let isTyping = false; // Global flag to indicate if typing is in progress
let replacements = []; // initilazilemeekmsmanehbuekvfty

// replace names in text
function replaceTextInElement(element) {
  // Skip replacements for inputs, textareas, contenteditable, and usernames
  if (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA' || element.hasAttribute('contenteditable') || element.closest('a')) {
    return;
  }

  const walker = document.createTreeWalker(
    element,
    NodeFilter.SHOW_TEXT,
    null,
    false
  );

  let node;
  while ((node = walker.nextNode())) {
    // Skip nodes that are clearly usernames by checking the color (rgb(174, 187, 201))
    if (!node.nodeValue.trim().startsWith('@') && !getComputedStyle(node.parentElement).color.includes('rgb(174, 187, 201)')) {
      replacements.forEach(({ oldName, newName }) => {
        const regex = new RegExp(`\\b${oldName}\\b`, 'gi');
        if (regex.test(node.nodeValue)) {
          node.nodeValue = node.nodeValue.replace(regex, newName);
        }
      });
    }
  }
}


// Function to apply the name replacements across like,,,, shit like the display name
function applyReplacements() {
  const targetSelectors = [
    // For profile display name
    'div[data-testid="profileHeaderDisplayName"]',

    // For display names in posts
    'a.css-1jxf684 span.css-1jxf684[style*="font-weight: 600;"]',

    // Exclude usernames by making sure they are not inside a[href]
    'div[dir="auto"]:not(a):not([style*="rgb(174, 187, 201)"])'
  ];


  targetSelectors.forEach(selector => {
    document.querySelectorAll(selector).forEach(element => {
      replaceTextInElement(element);
    });
  });
}


function handleTextInputAreas() {
  const postInput = document.querySelector('.bluesky-post-input-selector'); // Update with actual selector for the post input

  if (postInput) {
    postInput.addEventListener('focus', () => {
      isTyping = true; // set typing flag when focused
    });

    postInput.addEventListener('blur', () => {
      isTyping = false; // clear typing flag when blurred
      applyReplacements(); // reapply replacements after typing is done
    });
  } else {
    console.warn("Post input area not found. Retrying...");
    setTimeout(handleTextInputAreas, 500); // Retry after a short delay
  }
}


// set up a MO to detect changes in the DOM
function observeDOMChanges() {
  const observer = new MutationObserver(() => {
    // check if typing is in progress; skip replacements if so
    if (!isTyping) {
      applyReplacements(); // Reapply the replacements whenever the page / dom,,, changes
    }
  });

  observer.observe(document.body, {
    childList: true,
    subtree: true,
    characterData: true
  });

  handleTextInputAreas(); // setup
}

// Initialize the script
function initializeScript() {
  chrome.storage.local.get(['replacements'], ({ replacements: storedReplacements }) => {
    if (storedReplacements && storedReplacements.length > 0) {
      replacements = storedReplacements; // assign global replacements
      applyReplacements(); // apply initial replacements
      observeDOMChanges(); // set up the observer
    }
  });
}

// ....its obvious
initializeScript();
